/******************************************************************/
/* Pitarakise table 4b proge,                                     */
/* Muutsin ra jrgmised asjad:                                   */
/* a) seed1 = 5698001;                                            */
/* b) lisasin _i, et oleks kerge BIC1, BIC2 ja BIC3 vahel vahetada*/
/* c) tarstep2 juures raporteeri vasaku poole tulemused enne      */
/* d) qsort - kontrollib, kas jagub ja loikab "toelised" 10%      */
/* e) counting loogikale uued tingimused juurde (?)               */
/* f) tsykkel yle erinevate samplesize'de                         */
/* g) PROC TAR1 , annab vlja kas ghat voi puuduva vrtuse       */
/* h) +202 observations to get rid off startingvalue influences   */
/******************************************************************/
new;

format /m1 /ldn 8,3;

chdir c:\TARSpec\appl\unempl;

output file = c:\tarspec\citibase-BIC1-longdiff.OUT reset; 

load qt=citibase;
y = trimr(qt,1,0) - trimr(lag1(qt),1,0);

algus=time;
_trim = .10;     @ minimal percentage of data per regime @
_i=1;
_delay=2;

np=12;

n=1;
j=1;
k=1;
mhat1=zeros(n,3);  /* repl x rows(T_set) */
mhat21=zeros(n,3);
mhat22=zeros(n,3);
mhat321=zeros(n,3);
mhat322=zeros(n,3);
mhat323=zeros(n,3);
mhat324=zeros(n,3);
mhat331=zeros(n,3);
mhat332=zeros(n,3);
mhat333=zeros(n,3);
mhat334=zeros(n,3);
mhat=zeros(n,3);  /* teada on et kolm valimimahtu */

r1=zeros(n,3);
r21=zeros(n,3);
r22=zeros(n,3);

level2r=zeros(n,3);

r321=zeros(n,3);
r322=zeros(n,3);
r323=zeros(n,3);
r324=zeros(n,3);
r331=zeros(n,3);
r332=zeros(n,3);
r333=zeros(n,3);
r334=zeros(n,3);


_y_= y; 

n=rows(_y_);
ylag=zeros(n-np,np);

i=1;
do while i<=np;
   ylag[.,i]=_y_[np-i+1:n-i,1];                  /* All lags */
   i=i+1;
endo;

y=_y_[np+1:n,1];

yks=ones(rows(y),1);
x=yks~ylag;                             /* intercept + 12 lags of y */

tvarset=(cumsumc(X[.,2:cols(X)]'))'; 

do while _delay <=np;
"
*****************************************************************";
   "delay=" _delay;

    q=tvarset[.,_delay];


     t=rows(y);                     /* set new samplesize */

    
  /* ----------- 1. level --------------*/
  qq=qsort(q);

 {mhat1[1,1],r1[1,1]}=tar1(y,x,q,qq);
 
  if mhat1[j,k]==0;
    goto counting;
  endif;

/* -------------- 2. level ----------------*/
/* xxx21 corresponds to the left subsample */

{mhat21[1,1],mhat22[1,1],r21[1,1],r22[1,1]}=tarstep2(y,x,q,r1[1,1]);
/*"from tarstep2" mhat21[j,k]~mhat22[j,k]~r21[j,k]~r22[j,k];*/

/*
r21[j,k]=miss(mhat21[j,k]*r21[j,k],0);  /* if no actual break, set the    */
r22[j,k]=miss(mhat22[j,k]*r22[j,k],0);  /* corresp value to missing value */
*/

level2r[1,1:3]=(r21[j,k]|r1[j,k]|r22[j,k])';    /* Save break vector just in case */  

rsort=packr(r21[j,k]|r1[j,k]|r22[j,k]);      /* if any of the second level gammas was */
                                       /* missing then it's been eliminated now */ 


/* Depending on whether we have 2 or 3 breaks.... */

if rows(rsort)==1;   /* both sides empty */
 goto counting;
endif;
j=1;
k=1;
if rows(rsort)==2;
  {mhat321[j,k],mhat322[j,k],mhat323[j,k],mhat324[j,k],r321[j,k],r322[j,k],r323[j,k],r324[j,k]}
   =tarstep32(y,x,q,rsort[1],rsort[2]);
   
  if (mhat321[j,k]+mhat322[j,k]+mhat323[j,k]+mhat324[j,k])==0;
   /* "rows(rsort)==2 + 0 => goto counting"; */
    goto counting;  /* we had 2 breaks before and 0 new was found => m= 2 */
  endif; 
   
  if (mhat321[j,k]+mhat322[j,k]+mhat323[j,k]+mhat324[j,k])ge 2;
    /* "rows(rsort)==2 + 2 => goto counting";*/
    goto counting;  /* we had 2 breaks before and 2 or more is found => m= 4 at least  */
  endif;

  if (mhat321[j,k]+mhat322[j,k]+mhat323[j,k]+mhat324[j,k])==1;
  /* "rows(rsort)==2 + 1 => re-define rsort and run tarstep33";*/
   rsort=sortc(packr(r21[j,k]|r1[j,k]|r22[j,k]|r321[j,k]|r322[j,k]|r323[j,k]|r324[j,k]),1); 
  endif;

endif;


if rows(rsort)==3;
  {mhat331[j,k],mhat332[j,k],mhat333[j,k],mhat334[j,k],r331[j,k],r332[j,k],r333[j,k],r334[j,k]}
   =tarstep33(y,x,q,rsort[1],rsort[2],rsort[3]);
   
  if (mhat331[j,k]+mhat332[j,k]+mhat333[j,k]+mhat334[j,k])==0;
   /* "rows(rsort)==3 + 0 => goto counting";*/
    goto counting;  /* we had 3 breaks before and 0 new is found => m= 3 */
  
  elseif  (mhat331[j,k]+mhat332[j,k]+mhat333[j,k]+mhat334[j,k]) ge 1;
   /* "rows(rsort)==3 + 1 => goto counting";*/
    goto counting;  /* we had 3 breaks before and 1 or more is found => m= 4 at least  */
  endif;   
endif;

counting:

mhat[j,k]=mhat1[j,k]+mhat21[j,k]+mhat22[j,k]+mhat321[j,k]+mhat322[j,k]+mhat323[j,k]+mhat324[j,k]
+mhat331[j,k]+mhat332[j,k]+mhat333[j,k]+mhat334[j,k];

if mhat[j,k] ge 4;
  mhat[j,k]=4;
endif;


j~r1[j,k]~r21[j,k]~r22[j,k]~miss(r321[j,k],0)~miss(r322[j,k],0)~miss(r323[j,k],0)~miss(r324[j,k],0)~miss(r331[j,k],0)~miss(r332[j,k],0)~miss(r333[j,k],0)~miss(r334[j,k],0);

/*counts(mhat[.,k],0|1|2|3)';*/
_delay=_delay+1;
endo;
ttime=time_com(algus);
"Time wasted on this simulation=" ttime;

output off;
end;  

/***********************************************************************/
/***********************************************************************/
@ TAR Procedures @

/* FITS A TWO REGIME MODEL */

proc (2) = tar1(y,x,q,qq);
local mhat1,qt1,mi,e,sigsq,ic,t,x1,x2,gn,s,j,gg,ghat;
 t=rows(y)-cols(x);
 mi=inv(x'x); 
 e=y-x*mi*x'y;
 sigsq=e'e/t; 
 gn=rows(qq);
 s=zeros(gn,1);
 ic=zeros(gn,1);
 j=1;
 do while j<=gn;
    gg=qq[j];
    if scalmiss(gg); 
       continue; 
    endif;
    x1=x.*(q.<=gg);
    x2=x.*(q.>gg);
    /*s[j]=(y'y-y'x1*dinv(y,x1)-y'x2*dinv(y,x2))/t; */
     s[j]=(y'y-y'x1*inv(x1'x1)*x1'y-y'x2*inv(x2'x2)*x2'y)/t;
    ic[j]=t*ln(sigsq/s[j]);
    j=j+1;
 endo;
 
 qt1=maxc(ic)-_i*ln(t)*cols(x);  /*_i=1 => BIC1, _i=2 => BIC2, etc */
 
"qt1= " qt1;
 mhat1=0*(qt1<0)+1*(qt1>0);
 ghat=qq[minindc(s)];
 "ghat=" ghat;
 if NOT mhat1==0; 
/* " gamma and its main index" ghat~indexcat(sortc(q,1),ghat);*/
endif;
 
 if mhat1==0; 
   ghat=miss(0,0);
 endif;
 
retp(mhat1,ghat);
endp;


proc (4) = tarstep2(y,x,q,rhat1);
local qq1u,qq2u,rhat2,gg,qqcon,qq1,qq2,gg1,gg2,s1,s2,x1,x2,x3,gn1,gn2,s,j,k,
z1,y1,mz1,e1,sig1,z2,y2,mz2,e2,sig2,ic1,ic2,qt1,qt2,mhat21,mhat22,mhat2,
sig,z1hat,z2hat,q1hat,q2hat,m1,m2,g1,g2;

z1hat=x.*(q.<=rhat1);
z2hat=x.*(q.>=rhat1);

q1hat=eye(rows(z1hat))-z1hat*invpd(z1hat'z1hat)*z1hat';
q2hat=eye(rows(z2hat))-z2hat*invpd(z2hat'z2hat)*z2hat';

qq1u=packr(miss(q.*(q.>rhat1),0));
qq2u=packr(miss(q.*(q.<rhat1),0));

qq1=qsort(qq1u);
qq2=qsort(qq2u);

if NOT scalmiss(qq2);
  {m2,g2}=tar1(q2hat'y,q2hat'x,q,qq2);
 else;
  /*"too few obs to form new regime on LEFT-side";*/
 m2=0;
 g2=miss(0,0);
endif;

if NOT scalmiss(qq1);
  {m1,g1}=tar1(q1hat'y,q1hat'x,q,qq1);
 else;
 /* "too few obs to form new regime on RIGHT-side";*/
 m1=0;
 g1=miss(0,0);
endif;

retp(m2,m1,g2,g1); /* report left side first */
endp;


proc (8) = tarstep32(y,x,q,r1,r2);
local z1hat,z2hat,z3hat,q1hat,q2hat,q3hat,qq1u,qq2u,qq3u,qq1,qq2,qq3,m1,m2,m3,m4,g1,g2,g3,g4;

z1hat=x.*(q.<=r1);
z2hat=x.*(q.>r1 .and q.<=r2);
z3hat=x.*(q.>r2);

qq1u=packr(miss(q.*(q.<r1),0));
qq2u=packr(miss(q.*(q.>r1 .and q.<r2),0));
qq3u=packr(miss(q.*(q.>r2),0));

qq1=qsort(qq1u);
qq2=qsort(qq2u);
qq3=qsort(qq3u);

q1hat=eye(rows(z1hat))-z2hat*invpd(z2hat'z2hat)*z2hat'-
z3hat*invpd(z3hat'z3hat)*z3hat';

q2hat=eye(rows(z1hat))-z1hat*invpd(z1hat'z1hat)*z1hat'-
z3hat*invpd(z3hat'z3hat)*z3hat';

q3hat=eye(rows(z1hat))-z1hat*invpd(z1hat'z1hat)*z1hat'-
z2hat*invpd(z2hat'z2hat)*z2hat';

if NOT scalmiss(qq1);
  {m1,g1}=tar1(q1hat'y,q1hat'x,q,qq1);
 else;
 /*"too few obs to form new regime on 3-1";*/
 m1=0;
 g1=miss(0,0);
endif;


if NOT scalmiss(qq2);
  {m2,g2}=tar1(q2hat'y,q2hat'x,q,qq2);
 else;
/* "too few obs to form new regime on 3-2";*/
 m2=0;
 g2=miss(0,0);
endif;

if NOT scalmiss(qq3);
  {m3,g3}=tar1(q3hat'y,q3hat'x,q,qq3);
 else;
/*"too few obs to form new regime on 3-3";*/
 m3=0;
 g3=miss(0,0);
endif;

m4=0;
g4=miss(0,0);

retp(m1,m2,m3,m4,g1,g2,g3,g4);
endp;



proc (8) = tarstep33(y,x,q,r1,r2,r3);
local z1hat,z2hat,z3hat,z4hat,q1hat,q2hat,q3hat,q4hat,qq1u,qq2u,qq3u,
qq4u,qq1,qq2,qq3,qq4,m1,m2,m3,m4,g1,g2,g3,g4;

z1hat=x.*(q.<=r1);
z2hat=x.*(q.>r1 .and q.<=r2);
z3hat=x.*(q.>r2 .and q.<=r3);
z4hat=x.*(q.>r3);

qq1u=packr(miss(q.*(q.<r1),0));
qq2u=packr(miss(q.*(q.>r1 .and q.<r2),0));
qq3u=packr(miss(q.*(q.>r2 .and q.<r3),0));
qq4u=packr(miss(q.*(q.>r3),0));

qq1=qsort(qq1u);
qq2=qsort(qq2u);
qq3=qsort(qq3u);
qq4=qsort(qq4u);


q1hat=eye(rows(z1hat))-z2hat*invpd(z2hat'z2hat)*z2hat'-
z3hat*invpd(z3hat'z3hat)*z3hat'-z4hat*invpd(z4hat'z4hat)*z4hat';

q2hat=eye(rows(z1hat))-z1hat*invpd(z1hat'z1hat)*z1hat'-
z3hat*invpd(z3hat'z3hat)*z3hat'-z4hat*invpd(z4hat'z4hat)*z4hat';

q3hat=eye(rows(z1hat))-z1hat*invpd(z1hat'z1hat)*z1hat'-
z2hat*invpd(z2hat'z2hat)*z2hat'-z4hat*invpd(z4hat'z4hat)*z4hat';

q4hat=eye(rows(z1hat))-z1hat*invpd(z1hat'z1hat)*z1hat'-
z2hat*invpd(z2hat'z2hat)*z2hat'-z3hat*invpd(z3hat'z3hat)*z3hat';

if NOT scalmiss(qq1);
  {m1,g1}=tar1(q1hat'y,q1hat'x,q,qq1);
 else;
 /*"too few obs to form new regime on 3-1";*/
 m1=0;
 g1=miss(0,0);
endif;


if NOT scalmiss(qq2);
  {m2,g2}=tar1(q2hat'y,q2hat'x,q,qq2);
 else;
 /*"too few obs to form new regime on 3-2";*/
 m2=0;
 g2=miss(0,0);
endif;

if NOT scalmiss(qq3);
  {m3,g3}=tar1(q3hat'y,q3hat'x,q,qq3);
 else;
 /*"too few obs to form new regime on 3-3";*/
 m3=0;
 g3=miss(0,0);
endif;


if NOT scalmiss(qq4);
  {m4,g4}=tar1(q4hat'y,q4hat'x,q,qq4);
 else;
 /*"too few obs to form new regime on 3-4";*/
 m4=0;
 g4=miss(0,0);
endif;


retp(m1,m2,m3,m4,g1,g2,g3,g4);
endp;


proc ginv(m);
local mi;
  trap 1;
  mi=invpd(m);
  trap 0;
  if scalerr(mi);
    mi=pinv(m);
  endif;
retp(mi);
endp;

proc dinv(y,x);
local d;
  trap 1;
    d=y/x;
  trap 0;
  if scalerr(d);
    d=ginv(moment(x,0))*(x'y);
  endif;
retp(d);
endp;


proc qsort(q);
local j,n,n1,qq,qj,nj,qq1,qq2;
n=rows(y);
n1=round(_trim*n);
qq1=sortc(q,1);
if rows qq1 le (2*n1);
 /* print "inside qsort, too few obs";*/
 qq2=miss(0,0);
 else;
   qq2=qq1[n1+1:rows(qq1)-n1];
endif;

retp(qq2);
endp;

proc(1)=time_com(algus); /* need to place variable "algus" at the beginning of program */
                          /* returns time difference between algus and lopp  */
local lopp, vahe;

    lopp = time;
    vahe = lopp-algus;
    
    if vahe[4]<0;
        vahe[4] = vahe[4]+100;
        vahe[3]=vahe[3]-1;
    endif;  
    
    if vahe[3]<0;
        vahe[3] = vahe[3]+60;
        vahe[2]=vahe[2]-1;
    endif;
    
    if vahe[2]<0;
        vahe[2] = vahe[2]+60;
        vahe[1]=vahe[1]-1;
    endif;  
    
    if vahe[1]<0;
       vahe[1] = vahe[1]+24;
    endif;  
retp (timestr(vahe));
endp;


